Skip to content

Custom shortcuts

Use the ShortcutManager API to add, remove, replace, or block keyboard shortcuts in Handsontable.

  1. Access the ShortcutManager API:

    hot.getShortcutManager();
  2. Select a keyboard shortcut context, for example:

    const gridContext = hot.getShortcutManager().getContext('grid');
  3. Use the selected context’s methods. For example, to use the addShortcut() method in the grid context:

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.addShortcut({
    group: 'group_ID', // a string value; the user can decide on its name.
    // Each shortcut should be assigned to the group.
    keys: [['enter']],
    callback: () => {},
    });

Add a custom keyboard shortcut

To add a custom keyboard shortcut:

  1. Select a context in which you want to add a shortcut, for example:

    const gridContext = hot.getShortcutManager().getContext('grid');
  2. Using the selected context’s addShortcut() method, add your keyboard shortcut:

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.addShortcut({
    group: 'group_ID', // a string value; the user can decide on its name.
    // Each shortcut should be assigned to the group.
    keys: [['enter']],
    callback: () => {},
    });

Try it out

The example below registers a custom keyboard shortcut in the grid context, using the addShortcut() method. Select a cell and press Control/Cmd + Enter to insert a new row below it.

JavaScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const data = [
['SKU-4821', 'Wireless Mouse', 128, 'Electronics'],
['SKU-0093', 'Desk Lamp', 42, 'Home Goods'],
['SKU-7734', 'USB-C Cable', 310, 'Electronics'],
['SKU-2210', 'Notebook Set', 87, 'Office Supplies'],
['SKU-5567', 'Water Bottle', 156, 'Outdoor'],
];
const container = document.querySelector('#example1');
const hot = new Handsontable(container, {
data,
colHeaders: ['SKU', 'Product', 'Quantity', 'Category'],
columns: [{}, {}, { type: 'numeric' }, {}],
height: 'auto',
licenseKey: 'non-commercial-and-evaluation',
});
// get the `grid` context from the `ShortcutManager` API
const gridContext = hot.getShortcutManager().getContext('grid');
if (gridContext) {
// register a custom keyboard shortcut in the `grid` context:
// pressing Control/Meta+Enter inserts a new row below the selected cell
gridContext.addShortcut({
keys: [['control/meta', 'enter']],
group: 'insertRowBelow',
callback: () => {
const selected = hot.getSelectedRangeLast();
if (!selected || selected.highlight.row === null) {
return;
}
hot.alter('insert_row_below', selected.highlight.row);
},
});
}
TypeScript
import Handsontable from 'handsontable/base';
import { registerAllModules } from 'handsontable/registry';
// register Handsontable's modules
registerAllModules();
const data: (string | number)[][] = [
['SKU-4821', 'Wireless Mouse', 128, 'Electronics'],
['SKU-0093', 'Desk Lamp', 42, 'Home Goods'],
['SKU-7734', 'USB-C Cable', 310, 'Electronics'],
['SKU-2210', 'Notebook Set', 87, 'Office Supplies'],
['SKU-5567', 'Water Bottle', 156, 'Outdoor'],
];
const container: Element = document.querySelector('#example1')!;
const hot = new Handsontable(container, {
data,
colHeaders: ['SKU', 'Product', 'Quantity', 'Category'],
columns: [{}, {}, { type: 'numeric' }, {}],
height: 'auto',
licenseKey: 'non-commercial-and-evaluation',
});
// get the `grid` context from the `ShortcutManager` API
const gridContext = hot.getShortcutManager().getContext('grid');
if (gridContext) {
// register a custom keyboard shortcut in the `grid` context:
// pressing Control/Meta+Enter inserts a new row below the selected cell
gridContext.addShortcut({
keys: [['control/meta', 'enter']],
group: 'insertRowBelow',
callback: () => {
const selected = hot.getSelectedRangeLast();
if (!selected || selected.highlight.row === null) {
return;
}
hot.alter('insert_row_below', selected.highlight.row);
},
});
}

Add a conditional keyboard action

To make a keyboard action run on a certain condition, set the runOnlyIf parameter to a function:

const gridContext = hot.getShortcutManager().getContext('grid');
gridContext.addShortcut({
group: 'group_ID', // a string value; the user can decide on its name.
// Each shortcut should be assigned to the group.
runOnlyIf: () => hot.getSelected() !== void 0,
keys: [['enter']],
callback: () => {},
});

Set the order of keyboard actions

You can assign multiple actions to a single keyboard shortcut.

By default, when you assign a new action, it runs after any other actions that were assigned previously. To set your own order of actions, use the position and relativeToGroup parameters of the addShortcut() method:

const gridContext = hot.getShortcutManager().getContext('grid');
gridContext.addShortcut({
group: 'customNumericEditor',
position: 'before',
relativeToGroup: 'editorManager.handlingEditor',
runOnlyIf: () => {
hot.getSelected() !== void 0;
},
keys: [['F2']],
callback: () => {
if (hot.getActiveEditor().cellProperties.type === 'numeric') {
return false; // the `F2` shortcut won't work for `numeric` cells
}
// another action
},
});

Remove a keyboard shortcut

To remove a keyboard shortcut (e.g., one of the default keyboard shortcuts):

  1. Select a context in which you want to remove a keyboard shortcut.

  2. Use the selected context’s removeShortcutsByKeys() method.

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.removeShortcutsByKeys(['enter']);

To remove all keyboard shortcuts registered in a certain group:

  1. Select a context.

  2. Use the selected context’s removeShortcutsByGroup() method.

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.removeShortcutsByGroup('group_ID');

Replace a keyboard shortcut

To replace a keyboard shortcut:

  1. Select a context in which you want to replace a keyboard shortcut.

  2. Get the old keyboard shortcut, using the selected context’s getShortcuts() method.

  3. Remove the old keyboard shortcut, using the selected context’s removeShortcutsByKeys() method.

  4. Replace the keys property of the old keyboard shortcut with your new array of keys.

  5. Add your new keyboard shortcut, using the selected context’s addShortcuts() method.

    const gridContext = hot.getShortcutManager().getContext('grid');
    const undoShortcut = gridContext.getShortcuts(['control/meta', 'z']);
    gridContext.removeShortcutsByKeys(['control/meta', 'z']);
    undoShortcut.map((shortcut) => {
    shortcut.keys = [['shift', 'control/meta', 'z']];
    });
    gridContext.addShortcuts(undoShortcut);

Block a keyboard shortcut’s actions

To block a keyboard shortcut’s actions, return false in the beforeKeyDown hook’s callback:

hot.addHook('beforeKeyDown', (event) => {
// the `Enter` shortcut won't work
if (event.key === 'enter') {
return false;
}
});

Result

After completing these steps, you have custom keyboard shortcuts registered in the target context. The shortcuts trigger your callbacks when the user presses the configured key combination, and only when the specified context is active.

Reference

Keyboard shortcut contexts

Every keyboard action is registered in a particular context:

ContextDescriptionType
gridActivates when the user navigates the data grid (initial context)Built-in
editorActivates when the user opens a cell editorBuilt-in
menuActivates when the user opens a cell’s context menuBuilt-in
CustomYour custom contextCustom

When the user interacts with the keyboard, only actions registered for the currently-active context are executed. Only one context is active at a time.

Manage keyboard shortcut contexts

Using the ShortcutManager API methods, you can:

For example: if you’re using a complex custom editor, you can create a new shortcut context to navigate your editor’s UI with the arrow keys (normally, the arrow keys would navigate the grid instead).

addShortcut() parameters

The keys parameter:

  • Accepts all the KeyboardEvent.key key names.
  • Accepts key names in both lowercase and uppercase (e.g., both Enter and enter work)
  • Handles key-name discrepancies between browsers (e.g., both 'Spacebar' and ' ' work)
  • Accepts key names in any order (e.g., both [['control', 'a']] and [['a', 'control']]) work)

The control/meta key name is specific to Handsontable. It matches Control on Windows and Linux, and Meta on macOS. For arrow keys, use KeyboardEvent.key names such as ArrowLeft, not display glyphs such as ←.

API reference

For the list of options, methods, and Handsontable hooks related to keyboard navigation, see the following API reference pages:

APIs

Configuration options

Core methods

Hooks

Troubleshooting

Didn’t find what you need? Try this:

Skip to content

Custom shortcuts

Use the ShortcutManager API to add, remove, replace, or block keyboard shortcuts in Handsontable.

  1. Access the ShortcutManager API:

    hot.getShortcutManager();
  2. Select a keyboard shortcut context, for example:

    const gridContext = hot.getShortcutManager().getContext('grid');
  3. Use the selected context’s methods. For example, to use the addShortcut() method in the grid context:

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.addShortcut({
    group: 'group_ID', // a string value; the user can decide on its name.
    // Each shortcut should be assigned to the group.
    keys: [['enter']],
    callback: () => {},
    });

Add a custom keyboard shortcut

To add a custom keyboard shortcut:

  1. Select a context in which you want to add a shortcut, for example:

    const gridContext = hot.getShortcutManager().getContext('grid');
  2. Using the selected context’s addShortcut() method, add your keyboard shortcut:

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.addShortcut({
    group: 'group_ID', // a string value; the user can decide on its name.
    // Each shortcut should be assigned to the group.
    keys: [['enter']],
    callback: () => {},
    });

Try it out

The example below registers a custom keyboard shortcut in the grid context, using the addShortcut() method. Select a cell and press Control/Cmd + Enter to insert a new row below it.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type Handsontable from 'handsontable/base';
import type { GridSettings } from 'handsontable/settings';
// register Handsontable's modules
registerAllModules();
const data: (string | number)[][] = [
['SKU-4821', 'Wireless Mouse', 128, 'Electronics'],
['SKU-0093', 'Desk Lamp', 42, 'Home Goods'],
['SKU-7734', 'USB-C Cable', 310, 'Electronics'],
['SKU-2210', 'Notebook Set', 87, 'Office Supplies'],
['SKU-5567', 'Water Bottle', 156, 'Outdoor'],
];
const hotSettings = ref<GridSettings>({
data,
colHeaders: ['SKU', 'Product', 'Quantity', 'Category'],
columns: [{}, {}, { type: 'numeric' }, {}],
height: 'auto',
afterInit(this: Handsontable) {
// get the `grid` context from the `ShortcutManager` API
const gridContext = this.getShortcutManager().getContext('grid');
if (!gridContext) {
return;
}
// register a custom keyboard shortcut in the `grid` context:
// pressing Control/Meta+Enter inserts a new row below the selected cell
gridContext.addShortcut({
keys: [['control/meta', 'enter']],
group: 'insertRowBelow',
callback: () => {
const selected = this.getSelectedRangeLast();
if (!selected || selected.highlight.row === null) {
return;
}
this.alter('insert_row_below', selected.highlight.row);
},
});
},
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

Add a conditional keyboard action

To make a keyboard action run on a certain condition, set the runOnlyIf parameter to a function:

const gridContext = hot.getShortcutManager().getContext('grid');
gridContext.addShortcut({
group: 'group_ID', // a string value; the user can decide on its name.
// Each shortcut should be assigned to the group.
runOnlyIf: () => hot.getSelected() !== void 0,
keys: [['enter']],
callback: () => {},
});

Set the order of keyboard actions

You can assign multiple actions to a single keyboard shortcut.

By default, when you assign a new action, it runs after any other actions that were assigned previously. To set your own order of actions, use the position and relativeToGroup parameters of the addShortcut() method:

const gridContext = hot.getShortcutManager().getContext('grid');
gridContext.addShortcut({
group: 'customNumericEditor',
position: 'before',
relativeToGroup: 'editorManager.handlingEditor',
runOnlyIf: () => {
hot.getSelected() !== void 0;
},
keys: [['F2']],
callback: () => {
if (hot.getActiveEditor().cellProperties.type === 'numeric') {
return false; // the `F2` shortcut won't work for `numeric` cells
}
// another action
},
});

Remove a keyboard shortcut

To remove a keyboard shortcut (e.g., one of the default keyboard shortcuts):

  1. Select a context in which you want to remove a keyboard shortcut.

  2. Use the selected context’s removeShortcutsByKeys() method.

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.removeShortcutsByKeys(['enter']);

To remove all keyboard shortcuts registered in a certain group:

  1. Select a context.

  2. Use the selected context’s removeShortcutsByGroup() method.

    const gridContext = hot.getShortcutManager().getContext('grid');
    gridContext.removeShortcutsByGroup('group_ID');

Replace a keyboard shortcut

To replace a keyboard shortcut:

  1. Select a context in which you want to replace a keyboard shortcut.

  2. Get the old keyboard shortcut, using the selected context’s getShortcuts() method.

  3. Remove the old keyboard shortcut, using the selected context’s removeShortcutsByKeys() method.

  4. Replace the keys property of the old keyboard shortcut with your new array of keys.

  5. Add your new keyboard shortcut, using the selected context’s addShortcuts() method.

    const gridContext = hot.getShortcutManager().getContext('grid');
    const undoShortcut = gridContext.getShortcuts(['control/meta', 'z']);
    gridContext.removeShortcutsByKeys(['control/meta', 'z']);
    undoShortcut.map((shortcut) => {
    shortcut.keys = [['shift', 'control/meta', 'z']];
    });
    gridContext.addShortcuts(undoShortcut);

Block a keyboard shortcut’s actions

To block a keyboard shortcut’s actions, return false in the beforeKeyDown hook’s callback:

const hotSettings = ref({
beforeKeyDown(event) {
// the `Enter` shortcut won't work
if (event.key === 'enter') {
return false;
}
},
// ...other settings
});

Result

After completing these steps, you have custom keyboard shortcuts registered in the target context. The shortcuts trigger your callbacks when the user presses the configured key combination, and only when the specified context is active.

Reference

Keyboard shortcut contexts

Every keyboard action is registered in a particular context:

ContextDescriptionType
gridActivates when the user navigates the data grid (initial context)Built-in
editorActivates when the user opens a cell editorBuilt-in
menuActivates when the user opens a cell’s context menuBuilt-in
CustomYour custom contextCustom

When the user interacts with the keyboard, only actions registered for the currently-active context are executed. Only one context is active at a time.

Manage keyboard shortcut contexts

Using the ShortcutManager API methods, you can:

For example: if you’re using a complex custom editor, you can create a new shortcut context to navigate your editor’s UI with the arrow keys (normally, the arrow keys would navigate the grid instead).

addShortcut() parameters

The keys parameter:

  • Accepts all the KeyboardEvent.key key names.
  • Accepts key names in both lowercase and uppercase (e.g., both Enter and enter work)
  • Handles key-name discrepancies between browsers (e.g., both 'Spacebar' and ' ' work)
  • Accepts key names in any order (e.g., both [['control', 'a']] and [['a', 'control']]) work)

The control/meta key name is specific to Handsontable. It matches Control on Windows and Linux, and Meta on macOS. For arrow keys, use KeyboardEvent.key names such as ArrowLeft, not display glyphs such as ←.

API reference

For the list of options, methods, and Handsontable hooks related to keyboard navigation, see the following API reference pages:

APIs

Configuration options

Core methods

Hooks

Troubleshooting

Didn’t find what you need? Try this: